<!doctype html>
<html>
	<head>
		<meta charset="utf-8">

		<title>Introduction To Python</title>

		<meta name="description" content="A framework for easily creating beautiful presentations using HTML">
		<meta name="author" content="Hakim El Hattab">

		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/moon.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/zenburn.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
	</script>

		<!--[if lt IE 9]>
		<script src="lib/js/html5shiv.js"></script>
		<![endif]-->
	</head>
	<body>
		<div class="reveal">
			<div class="slides">



				<section>
					<h1>Python</h1>
					<img src="images/logo.jpeg"/>
					<h3>An introduction</h3>
					<a href="https://gitlab.com/sheena.oconnell/presentation-intro-to-python/blob/master/examples.py">https://gitlab.com/sheena.oconnell/presentation-intro-to-python/blob/master/examples.py</a>
				</section>

				<section>
					<h1>Ice breaker</h1>
					<img src="images/fat-penguine.jpeg" height="350em"/><br/>
				</section>

				<section>
					<h1>Contents</h1>
					<ul>
						<li>Python is...</li>
						<li>Killer Application</li>
						<li>Python versus...</li>
						<li>Who uses it?</li>
						<li>-- A small interlude --</li>
						<li>Code examples</li>
					</ul>
				</section>

				<section>
					<h1>Python...</h1>
					<section></section>

					<section>
						<ul>
							<li>runs on all major platforms</li>
							<li>has a big and passionate developer community</li>
							<li>has a robust and powerful standard library</li>
							<li>many open source frameworks and tools</li>
						</ul>
					</section>

					<section>
						<h3>...is Multi Paradigm</h3>
						<ul>
							<li>Object Orientated</li>
							<li>Supports Aspect Orientated</li>
							<li>Supports Functional</li>
						</ul>
					</section>

					<section>
						<h3>...puts emphasis on</h3>
						<ul>
							<li>Readability</li>
							<li>Programmer speed and happiness</li>
							<li>NOT program speed</li>
						</ul>
					</section>

					<section>
						<h3>...is</h3>
						<ul>
							<li>High level</li>
							<li>Interpreted</li>
							<li>Interactive</li>
							<li>Dynamically typed</li>
							<li>automatically garbage collected</li>
							<li>Extensible in C++ & C</li>
						</ul>
					</section>
				</section>

				<section>
					<section>
						<h1>Killer Application?</h1>
					</section>

					<section>
						<h2>Jack of many trades...</h2>
						<h2> ...also master of many trades</h2>
					</section>


					<section>
						<h3>Web and Internet</h3>
						<img src="images/web_frameworks.png">
					</section>

					<section>
						<h3>Scientific and numeric</h3>
						<img src="images/numeric.png">

					</section>


					<section>
						<h3> Etc </h3>
						<img src="images/misc.png">

					</section>

					<section>
						<img src="images/xkcd.png" height="450em"/><br/>
						<a href="https://xkcd.com/353/">https://xkcd.com/353/</a>
					</section>


					<section>
						<h3>Awesome Python</h3>
						<img src="images/awesome.svg" height="150em"/><br/>
						<a href="https://github.com/vinta/awesome-python">
						https://github.com/vinta/awesome-python
						</a>
					</section>

				</section>


				<section>

					<section>
						<img src="images/python_versus.png">
					</section>

					<section>
						<h3>Java, C, C++, C#</h3>
						<p>
							Unlike these, Python is
						</p>
						<ul>
							<li>Higher level</li>
							<li>Interactive</li>
							<li>Interpreted</li>
							<li>Dynamically Typed</li>
							<li>Garbage Collected</li>
							<li>Fast to write / slower to run</li>
							<li>No proper threading</li>
						</ul>
					</section>

					<section>
						<h3>Clojure</h3>
						<p>is...</p>
						<ul>
							<li>Compiled (Java runtime)</li>
							<li>REPL (Read Eval Print Loop)</li>
							<li>Faster than Python</li>
							<li>Not OO</li>
							<li>Data is first class, and mostly immutable</li>
							<li>Community is small</li>
							<li>No pip equivalent that I can find... uses jars</li>
						</ul>

					</section>

					<section>
						<h3>R</h3>
						<ul>
							<li>R Focus on data analysis</li>
							<li>Python focus on productivity and readability</li>
							<li>R mostly used in academic setting, but use is expanding</li>
							<li>Python adopted more by people who already code</li>
							<li>Python more versatile</li>
							<li>R: Statistical models quick to write</li>
							<li>Python: Easier to debug</li>
							<li>
								<a href="https://www.datacamp.com/community/tutorials/r-or-python-for-data-analysis">
								r-or-python-for-data-analysis
								</a>

							</li>
						</ul><br/>
					</section>

					<section>
						<h3>Ruby, PHP</h3>
						<p>These are interpreted, just like Python. But </p>

						<ul>
							<li>Python is easier to learn</li>
							<li>Python is more general purpose</li>
							<li>PHP has a larger footprint (+- 80% of web)</li>
							<li>Python package management better than PHP</li>
							<li>Python more explicit(less magical) than Ruby</li>
							<li>Python easy to debug</li>
							<li><a href="https://www.youtube.com/watch?v=b48XWPTbapA">Ruby vs Python: Choosing Your First Programming Language</a></li>
							<li><a href="https://www.quora.com/Which-is-better-PHP-or-Python-Why">Which is better, PHP or Python? Why?</a></li>

						</ul>
					</section>


					<section>
						<h3>JavaScript + Node.js (etc)</h3>

						<ul>
							<li>Python is not run by browsers</li>
							<li>Node.js unlocks JS for backends</li>
							<li>Node.js is faster, better at async</li>
							<li>Python wins on debugging</li>
							<li>Python is cleaner</li>
							<li>JS fatigue</li>
							<li>Python requires fewer lines of code. More productive</li>
							<li>Node.js best at real time IO web apps (eg browser-based games, chat etc)</li>
						</ul>

					</section>

					<section>

						<h3>Golang</h3>
						<ul>
							<li>Googley</li>
							<li>Simple, scalable, threading</li>
							<li>compiled</li>
							<li>OO</li>
							<li>Not considered a good "first language"</li>
							<li>Introspection bad</li>
							<li>Ties your hands - bad programmers can't do much damage, good programmers are frustrated</li>
						</ul>

					</section>
				</section>

				<section>
					<h1>Who is using it?</h1>

					<img src="images/python_companies.png">
				</section>

				<section>
					<h1><xmp><br/></xmp></h1>

				</section>

				<section>
					<h2>And now for something completely different</h2>
					<img src="images/foot.jpeg" height="350em"/>
				</section>

				<section>

				<section>
					<h1>Code Examples</h1>
				</section>

				<section>
					<h2>Helloworld</h2>
					<pre><code class="hljs" data-trim contenteditable>

>>> print('hello world')
hello world

					</code></pre>
				</section>



				<section>
					<h2>Functions + whitespace</h2>
					<pre><code class="hljs" data-trim contenteditable>
# saved in examples.py

def print_repeated(s,i=1):
    """print s i times, then return the printed value
    Args:
        s (str): the string
        i (int): how many times should we print i
    Returns:
        str: the printed value
    """
    computed_value = s * i
    print(computed_value)
    return computed_value

</code></pre>
examples.py available at
<a href="https://gitlab.com/sheena.oconnell/presentation-intro-to-python/blob/master/examples.py">https://gitlab.com/sheena.oconnell/presentation-intro-to-python/blob/master/examples.py</a>

</section>
<section>
	<h2>Imports and more function calls</h2>
	<pre><code class="hljs" data-trim contenteditable>
>>> from examples import print_repeated
>>> x = print_repeated('hello')
hello
>>> x
'hello'
>>> y = print_repeated('winning ',3)
winning winning winning
>>> y
'winning winning winning '
>>> z = print_repeated(5,2.5)
12.5
>>> z
12.5
	</code></pre>
</section>



<section>
<h2>Exceptions</h2>
<pre><code class="hljs" data-trim contenteditable>
>>> a = print_repeated('foo','bar')
Traceback (most recent call last):
  File "&ltstdin>", line 1, in &ltmodule>
  File "/home/sheena/workspace/intro-to-python/examples.py", line 9, in print_repeated
    computed_value = s * i
TypeError: can't multiply sequence by non-int of type 'str'

</code></pre>
</section>

<section>
<h2>Our first class</h2>
<pre><code class="hljs" data-trim contenteditable>
# examples.py
class Insect:
    def __init__(self):
        print("hatching insect: ",self)

</code></pre>

</section>

<section>
<h2>Making some insects</h2>
<pre><code class="hljs" data-trim contenteditable>
>>> from examples import Insect
>>> Insect
&ltclass 'examples.Insect'>
>>> o1 = Insect()
hatching insect:  &ltexamples.Insect object at 0x7f0205543470>
>>> o2 = Insect()
hatching insect:  &ltexamples.Insect object at 0x7f0205559da0>
>>>
>>> o1
&ltexamples.Insect object at 0x7f0205543470>
>>> o2
&ltexamples.Insect object at 0x7f0205559da0>
>>> o1==o2
False

</code></pre>
</section>


<section>
<h2>inheritance and magic methods</h2>
<pre><code class="hljs" data-trim contenteditable>
# examples.py
class Moth(Insect):
    def __repr__(self):
        return "The little moth that could " + str(id(self))
</code></pre>


</section>


<section>
<h2>Make some moths</h2>
<pre><code class="hljs" data-trim contenteditable>
>>> from examples import Moth
>>> o = Moth()
hatching insect:  The little moth that could 139646656066280
>>> o
The little moth that could 139646656066280

</code></pre>
</section>

<section>
	<h2>Bees!</h2>
<pre><code class="hljs" data-trim contenteditable>
#example.py

class Bee(Insect):
    all_bees = []
    has_pollen = False

    def __init__(self):
        super(Bee,self).__init__()
        Bee.all_bees.append(self)

    def __repr__(self):
        if self.has_pollen:
            return "&ltBee (Full)>"
        else:
            return "&ltBee (Empty)>"

    def deposit_pollen(self):
        assert self.has_pollen, "must gather pollen first"
        self.has_pollen = False
        print("Pollen successfully deposited.")

    def gather_pollen(self):
        assert not self.has_pollen, "must deposit pollen first"
        self.has_pollen = True
        print("Pollen successfully gathered.")

</code></pre>
</section>


<section>
	<h2>Gather some pollen</h2>
<pre><code class="hljs" data-trim contenteditable>
>>> from examples import Bee
>>> bee = Bee()
hatching insect:  &ltBee (Empty)>
>>>
>>> bee.deposit_pollen()
Traceback (most recent call last):
  File "&ltstdin>", line 1, in &ltmodule>
  File "&ltstdin>", line 13, in deposit_pollen
AssertionError: must gather pollen first
>>> bee.gather_pollen()
Pollen successfully gathered.
>>> bee
&ltBee (Full)>
>>> bee.gather_pollen()
Traceback (most recent call last):
  File "&ltstdin>", line 1, in &ltmodule>
  File "&ltstdin>", line 17, in gather_pollen
AssertionError: must deposit pollen first
>>> bee.deposit_pollen()
Pollen successfully deposited.
>>> bee
&ltBee (Empty)>

</code></pre>
</section>

<section>
<h2>Moar Bees!</h2>
<pre><code class="hljs" data-trim contenteditable>
>>> bee
&ltBee (Empty)>
>>> bee.all_bees
[&ltBee (Empty)>]
>>> id(bee.all_bees) == id(Bee.all_bees)
True
>>> [Bee() for i in range(5)]
hatching insect:  &ltBee (Empty)>
hatching insect:  &ltBee (Empty)>
hatching insect:  &ltBee (Empty)>
hatching insect:  &ltBee (Empty)>
hatching insect:  &ltBee (Empty)>
[&ltBee (Empty)>, &ltBee (Empty)>, &ltBee (Empty)>, &ltBee (Empty)>, &ltBee (Empty)>]
>>> bee.all_bees
[&ltBee (Empty)>, &ltBee (Empty)>, &ltBee (Empty)>, &ltBee (Empty)>, &ltBee (Empty)>, &ltBee (Empty)>]
>>> bee.all_bees[0] == bee
True
>>> bee.all_bees[1] == bee
False

</code></pre>
</section>

<section data-background="images/bees.gif" data-background-size="20em"></section>


<section>
<h2>Hello Introspection</h2>
<pre><code class="hljs" data-trim contenteditable>
>>> type(1)
&ltclass 'int'>
>>> type('hello')
&ltclass 'str'>
>>> type(print)
&ltclass 'builtin_function_or_method'>
>>> from examples import print_repeated
>>> type(print_repeated)
&ltclass 'function'>
>>> help(print_repeated)
Help on function print_repeated in module examples:

print_repeated(s, i=1)
    print s i times, then return the printed value
    Args:
        s (str): the string
        i (int): how many times should we print i
    Returns:
        str: the printed value
(END)



</code></pre>
</section>

<section>
<h3>Help!</h3>
<pre><code class="hljs" data-trim contenteditable>

Help on class Bee in module examples:

class Bee(Insect)
 |  Method resolution order:
 |      Bee
 |      Insect
 |      builtins.object
 |
 |  Methods defined here:
 |
 |  __init__(self)
 |      Initialize self.  See help(type(self)) for accurate signature.
 |
 |  __repr__(self)
 |      Return repr(self).
 |
 |  deposit_pollen(self)
 |
 |  gather_pollen(self)
 |
 |  ----------------------------------------------------------------------
 |  Data and other attributes defined here:
 |
 |  all_bees = []
 |
 |  has_pollen = False
 |
 |  ----------------------------------------------------------------------
 |  Data descriptors inherited from Insect:
 |
 |  __dict__
 |      dictionary for instance variables (if defined)
 |
 |  __weakref__
 |      list of weak references to the object (if defined)

</code></pre>
</section>

<section>
<h3>Dir</h3>
<pre><code class="hljs" data-trim contenteditable>
>>> dir(Bee)
['__class__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', 'all_bees', 'deposit_pollen', 'gather_pollen', 'has_pollen']
>>> Bee.gather_pollen
&ltfunction Bee.gather_pollen at 0x7f906ff08ea0>
>>> bee.gather_pollen
&ltbound method Bee.gather_pollen of &ltBee (Empty)>>
>>> Bee.gather_pollen()
Traceback (most recent call last):
  File "&ltstdin>", line 1, in &ltmodule>
TypeError: gather_pollen() missing 1 required positional argument: 'self'
>>> bee.gather_pollen()
Pollen successfully gathered.
>>> Bee.deposit_pollen(bee)
Pollen successfully deposited.
</code></pre>
</section>


<section>
<h2>Package management</h2>
<pre><code class="hljs" data-trim contenteditable>
pip install qrcode
pip install pillow
python
>>> import qrcode
>>> url = 'https://pres-intro-python-dot-prelude-za.appspot.com/'
>>> img = qrcode.make(url)
>>> with open('qr.png','wb') as f:
>>>     img.save(f)
</code></pre>
</section>

				</section>

				<section>
					<h1><a href="http://sheenacv.prelude.co.za/">Me :)</a></h1>
					<ul>
						<li>Been coding in some form for over 10 years</li>
						<li>Specialize in Python + K8s + Google Cloud</li>
						<li>Currently bootstrapping a medical startup</li>
						<li>Currently working on react+redux+graphql</li>
						<li><a href="https://www.codementor.io/sheena/posts">Codementor Writings</a></li>
					</ul>
				</section>

				<section>
					<h1>The End</h1>
				</section>

				<section>
					<a href="https://pres-intro-python-dot-prelude-za.appspot.com/">https://pres-intro-python-dot-prelude-za.appspot.com/</a><br/>
					<img src="images/qr.png"/>
				</section>

			</div>
		</div>

		<script src="lib/js/head.min.js"></script>
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/highlight/highlight.js', async: true, callback: function() {
						hljs.initHighlightingOnLoad();
					} }
				]
			});
		</script>
	</body>
</html>
